interface APICredentials {
    apiURL?: string;
    token: string;
}
interface ContextCredentials {
    contextURL: string;
    token: string;
}
interface BlobsOptions {
    authentication: APICredentials | ContextCredentials;
    context?: string;
    fetcher?: typeof globalThis.fetch;
    siteID: string;
}
declare enum ResponseType {
    ArrayBuffer = "arrayBuffer",
    Blob = "blob",
    JSON = "json",
    Stream = "stream",
    Text = "text"
}
interface SetOptions {
    ttl?: Date | number;
}
type BlobInput = ReadableStream | string | ArrayBuffer | Blob;
export declare class Blobs {
    private authentication;
    private context;
    private fetcher;
    private siteID;
    constructor({ authentication, context, fetcher, siteID }: BlobsOptions);
    private getFinalRequest;
    private static getTTLHeaders;
    private isConfigured;
    private makeStoreRequest;
    delete(key: string): Promise<void>;
    get(key: string): Promise<string>;
    get(key: string, { type }: {
        type: ResponseType.ArrayBuffer;
    }): Promise<ArrayBuffer>;
    get(key: string, { type }: {
        type: ResponseType.Blob;
    }): Promise<Blob>;
    get(key: string, { type }: {
        type: ResponseType.Stream;
    }): Promise<ReadableStream | null>;
    get(key: string, { type }: {
        type: ResponseType.Text;
    }): Promise<string>;
    set(key: string, data: BlobInput, { ttl }?: SetOptions): Promise<void>;
    setJSON(key: string, data: unknown, { ttl }?: SetOptions): Promise<void>;
}
export {};
